(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('tslib')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common/http', 'tslib'], factory) :
	(factory((global.ngxForkableHttpClient = global.ngxForkableHttpClient || {}),global.ng.core,global.ng.common.http,global.tslib));
}(this, (function (exports,_angular_core,_angular_common_http,tslib_1) { 'use strict';

function createInterceptorHandler(baseHandler, interceptors) {
    return interceptors.reduceRight(function (next, interceptor) { return new HttpInterceptorHandler(next, interceptor); }, baseHandler);
}
var HttpInterceptorHandler = (function () {
    function HttpInterceptorHandler(next, interceptor) {
        this.next = next;
        this.interceptor = interceptor;
    }
    HttpInterceptorHandler.prototype.handle = function (request) {
        return this.interceptor.intercept(request, this.next);
    };
    return HttpInterceptorHandler;
}());

var ForkableHttpClient = (function (_super) {
    tslib_1.__extends(ForkableHttpClient, _super);
    function ForkableHttpClient(backend, interceptors) {
        var _this = _super.call(this, createInterceptorHandler(backend, interceptors || [])) || this;
        _this.backend = backend;
        _this.interceptors = interceptors;
        return _this;
    }
    ForkableHttpClient.prototype.fork = function () {
        var interceptors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            interceptors[_i] = arguments[_i];
        }
        return new ForkableHttpClient(this.backend, this.interceptors.concat(interceptors));
    };
    return ForkableHttpClient;
}(_angular_common_http.HttpClient));
ForkableHttpClient.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ForkableHttpClient.ctorParameters = function () { return [
    { type: _angular_common_http.HttpBackend, },
    { type: Array, decorators: [{ type: _angular_core.Optional }, { type: _angular_core.Inject, args: [_angular_common_http.HTTP_INTERCEPTORS,] },] },
]; };
function forkHttpClient(parent) {
    var interceptors = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        interceptors[_i - 1] = arguments[_i];
    }
    return parent.fork.apply(parent, interceptors);
}

var ForkableHttpClientModule = (function () {
    function ForkableHttpClientModule() {
    }
    return ForkableHttpClientModule;
}());
ForkableHttpClientModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [
                    _angular_common_http.HttpClientModule
                ],
                providers: [
                    ForkableHttpClient
                ]
            },] },
];
/** @nocollapse */
ForkableHttpClientModule.ctorParameters = function () { return []; };

exports.ForkableHttpClientModule = ForkableHttpClientModule;
exports.ForkableHttpClient = ForkableHttpClient;
exports.forkHttpClient = forkHttpClient;
exports.createInterceptorHandler = createInterceptorHandler;
exports.HttpInterceptorHandler = HttpInterceptorHandler;

Object.defineProperty(exports, '__esModule', { value: true });

})));
